ArgumentException ArgumentException ArgumentException ArgumentException Class

Definição

A exceção que é gerada quando um dos argumentos fornecidos para um método não é válido.The exception that is thrown when one of the arguments provided to a method is not valid.

public ref class ArgumentException : SystemException
[System.Runtime.InteropServices.ComVisible(true)]
[System.Serializable]
public class ArgumentException : SystemException
type ArgumentException = class
    inherit SystemException
    interface ISerializable
Public Class ArgumentException
Inherits SystemException
Herança
Derivado
Atributos
Implementações

Exemplos

O exemplo a seguir demonstra como lançar e capturar um ArgumentException.The following example demonstrates how to throw and catch an ArgumentException. Ele usa ArgumentException. GetType (). Nome propriedade para exibir o nome do objeto de exceção e também usa a Message propriedade para exibir o texto da mensagem de exceção.It uses the ArgumentException.GetType().Name property to display the name of the exception object, and also uses the Message property to display the text of the exception message.

using namespace System;

static int DivideByTwo(int num) 
{
    // If num is an odd number, throw an ArgumentException.
    if ((num & 1) == 1)
        throw gcnew ArgumentException(String::Format("{0} is not an even number", num), 
                                      "num");

    // num is even, return half of its value.
    return num / 2;
}

void main() 
{
    // Define some integers for a division operation.
    array<int>^ values = { 10, 7 };
    for each (int value in values) {
        try {
           Console::WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value));
        }
        catch (ArgumentException^ e) {
           Console::WriteLine("{0}: {1}", e->GetType()->Name, e->Message);
        }
        Console::WriteLine();
    }
}
// This example displays the following output:
//     10 divided by 2 is 5
//     
//     ArgumentException: 7 is not an even number
//     Parameter name: num
using System;

public class Example 
{
    static void Main() 
    {
        // Define some integers for a division operation.
        int[] values = { 10, 7 };
        foreach (var value in values) {
            try {
               Console.WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value));
            }
            catch (ArgumentException e) {
               Console.WriteLine("{0}: {1}", e.GetType().Name, e.Message);
            }
            Console.WriteLine();
        }
    }

    static int DivideByTwo(int num) 
    {
        // If num is an odd number, throw an ArgumentException.
        if ((num & 1) == 1)
            throw new ArgumentException(String.Format("{0} is not an even number", num), 
                                      "num");

        // num is even, return half of its value.
        return num / 2;
    }
}
// This example displays the following output:
//     10 divided by 2 is 5
//     
//     ArgumentException: 7 is not an even number
//     Parameter name: num
Public Class Example
    Public Shared Sub Main()
        ' Define some integers for a division operation.
        Dim values() As Integer = { 10, 7 }

        For Each value In values
            Try 
               Console.WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value))
            Catch e As ArgumentException
               Console.WriteLine("{0}: {1}", e.GetType().Name, e.Message)
            End Try
            Console.WriteLine()
        Next
    End Sub
    
    Private Shared Function DivideByTwo(ByVal num As Integer) As Integer
        ' If num is an odd number, throw an ArgumentException.
        If (num And 1) = 1 Then
            Throw New ArgumentException(String.Format("{0} is not an even number", num), 
                                      "num")
        End If
        Return num \ 2
    End Function
End Class
' The example displays the following output:
'     10 divided by 2 is 5
'     
'     ArgumentException: 7 is not an even number
'     Parameter name: num

Comentários

ArgumentExceptioné gerado quando um método é invocado e pelo menos um dos argumentos passados não atende à especificação de parâmetro do método chamado.ArgumentException is thrown when a method is invoked and at least one of the passed arguments does not meet the parameter specification of the called method. A ParamName propriedade identifica o argumento inválido.The ParamName property identifies the invalid argument.

Normalmente, um ArgumentException é lançado pelo Common Language Runtime ou outra biblioteca de classes e indica erro do desenvolvedor.Most commonly, an ArgumentException is thrown by the common language runtime or another class library and indicates developer error. Se você lançar um ArgumentException do seu código, deverá garantir que a propriedade da Message exceção inclua uma mensagem de erro significativa que descreva o argumento inválido e o intervalo de valores esperado para o argumento.If you throw an ArgumentException from your code, you should ensure that the exception's Message property includes a meaningful error message that describes the invalid argument and the expected range of values for the argument.

As classes derivadas primárias ArgumentException do ArgumentNullException são ArgumentOutOfRangeExceptione.The primary derived classes of ArgumentException are ArgumentNullException and ArgumentOutOfRangeException. Essas classes derivadas devem ser usadas em vez ArgumentExceptionde, exceto em situações em que nenhuma das classes derivadas é aceitável.These derived classes should be used instead of ArgumentException, except in situations where neither of the derived classes is acceptable. Por exemplo, exceções devem ser lançadas por:For example, exceptions should be thrown by:

  • ArgumentNullExceptionsempre null que é passado para um método que não o aceita como um argumento válido.ArgumentNullException whenever null is passed to a method that does not accept it as a valid argument.

  • ArgumentOutOfRangeExceptionQuando o valor de um argumento está fora do intervalo de valores aceitáveis; por exemplo, quando o valor "46" é passado como o argumento de mês durante a criação de DateTimeum.ArgumentOutOfRangeException when the value of an argument is outside the range of acceptable values; for example, when the value "46" is passed as the month argument during the creation of a DateTime.

Se a chamada de método não tiver nenhum argumento ou se a falha não envolver os próprios argumentos, InvalidOperationException deverá ser usada.If the method call does not have any argument or if the failure does not involve the arguments themselves, then InvalidOperationException should be used.

ArgumentExceptionusa o HRESULT COR_E_ARGUMENT, que tem o valor 0x80070057.ArgumentException uses the HRESULT COR_E_ARGUMENT, which has the value 0x80070057.

Para obter uma lista de valores de propriedade inicial para uma instância do ArgumentException, consulte o ArgumentException construtores.For a list of initial property values for an instance of ArgumentException, see the ArgumentException constructors.

Construtores

ArgumentException() ArgumentException() ArgumentException() ArgumentException()

Inicializa uma nova instância da classe ArgumentException.Initializes a new instance of the ArgumentException class.

ArgumentException(SerializationInfo, StreamingContext) ArgumentException(SerializationInfo, StreamingContext) ArgumentException(SerializationInfo, StreamingContext) ArgumentException(SerializationInfo, StreamingContext)

Inicializa uma nova instância da classe ArgumentException com dados serializados.Initializes a new instance of the ArgumentException class with serialized data.

ArgumentException(String) ArgumentException(String) ArgumentException(String) ArgumentException(String)

Inicializa uma nova instância da classe ArgumentException com uma mensagem de erro especificada.Initializes a new instance of the ArgumentException class with a specified error message.

ArgumentException(String, Exception) ArgumentException(String, Exception) ArgumentException(String, Exception) ArgumentException(String, Exception)

Inicializa uma nova instância da classe ArgumentException com uma mensagem de erro especificada e uma referência à exceção interna que é a causa da exceção.Initializes a new instance of the ArgumentException class with a specified error message and a reference to the inner exception that is the cause of this exception.

ArgumentException(String, String) ArgumentException(String, String) ArgumentException(String, String) ArgumentException(String, String)

Inicializa uma nova instância da classe ArgumentException com uma mensagem de erro especificada e o nome do parâmetro que causa essa exceção.Initializes a new instance of the ArgumentException class with a specified error message and the name of the parameter that causes this exception.

ArgumentException(String, String, Exception) ArgumentException(String, String, Exception) ArgumentException(String, String, Exception) ArgumentException(String, String, Exception)

Inicializa uma nova instância da classe ArgumentException com uma mensagem de erro especificada, o nome do parâmetro e uma referência à exceção interna que é a causa dessa exceção.Initializes a new instance of the ArgumentException class with a specified error message, the parameter name, and a reference to the inner exception that is the cause of this exception.

Propriedades

Data Data Data Data

Obtém uma coleção de pares de chave/valor que fornecem informações adicionais definidas pelo usuário sobre a exceção.Gets a collection of key/value pairs that provide additional user-defined information about the exception.

(Inherited from Exception)
HelpLink HelpLink HelpLink HelpLink

Obtém ou define um link para o arquivo de ajuda associado a essa exceção.Gets or sets a link to the help file associated with this exception.

(Inherited from Exception)
HResult HResult HResult HResult

Obtém ou define HRESULT, um valor numérico codificado que é atribuído a uma exceção específica.Gets or sets HRESULT, a coded numerical value that is assigned to a specific exception.

(Inherited from Exception)
InnerException InnerException InnerException InnerException

Obtém a instância Exception que causou a exceção atual.Gets the Exception instance that caused the current exception.

(Inherited from Exception)
Message Message Message Message

Obtém a mensagem de erro e o nome do parâmetro ou apenas a mensagem de erro se não houver nenhum nome de parâmetro definido.Gets the error message and the parameter name, or only the error message if no parameter name is set.

ParamName ParamName ParamName ParamName

Obtém o nome do parâmetro que causa essa exceção.Gets the name of the parameter that causes this exception.

Source Source Source Source

Obtém ou define o nome do aplicativo ou objeto que causa o erro.Gets or sets the name of the application or the object that causes the error.

(Inherited from Exception)
StackTrace StackTrace StackTrace StackTrace

Obtém uma representação de cadeia de caracteres de quadros imediatos na pilha de chamadas.Gets a string representation of the immediate frames on the call stack.

(Inherited from Exception)
TargetSite TargetSite TargetSite TargetSite

Obtém o método que gerou a exceção atual.Gets the method that throws the current exception.

(Inherited from Exception)

Métodos

Equals(Object) Equals(Object) Equals(Object) Equals(Object)

Determina se o objeto especificado é igual ao objeto atual.Determines whether the specified object is equal to the current object.

(Inherited from Object)
GetBaseException() GetBaseException() GetBaseException() GetBaseException()

Quando substituído em uma classe derivada, retorna a Exception que é a causa raiz de uma ou mais exceções subsequentes.When overridden in a derived class, returns the Exception that is the root cause of one or more subsequent exceptions.

(Inherited from Exception)
GetHashCode() GetHashCode() GetHashCode() GetHashCode()

Serve como a função de hash padrão.Serves as the default hash function.

(Inherited from Object)
GetObjectData(SerializationInfo, StreamingContext) GetObjectData(SerializationInfo, StreamingContext) GetObjectData(SerializationInfo, StreamingContext) GetObjectData(SerializationInfo, StreamingContext)

Define o objeto SerializationInfo com o nome do parâmetro e informações adicionais de exceção.Sets the SerializationInfo object with the parameter name and additional exception information.

GetType() GetType() GetType() GetType()

Obtém o tipo de tempo de execução da instância atual.Gets the runtime type of the current instance.

(Inherited from Exception)
MemberwiseClone() MemberwiseClone() MemberwiseClone() MemberwiseClone()

Cria uma cópia superficial do Object atual.Creates a shallow copy of the current Object.

(Inherited from Object)
ToString() ToString() ToString() ToString()

Cria e retorna uma representação de cadeia de caracteres da exceção atual.Creates and returns a string representation of the current exception.

(Inherited from Exception)

Eventos

SerializeObjectState SerializeObjectState SerializeObjectState SerializeObjectState

Ocorre quando uma exceção é serializada para criar um objeto de estado de exceção que contém dados serializados sobre a exceção.Occurs when an exception is serialized to create an exception state object that contains serialized data about the exception.

(Inherited from Exception)

Aplica-se a

Veja também